///home/berryj/link/bin/genMethods "-g" "-t" "char*" "-h" "List" "-I" "LINK/basic/List.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/List.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef char* _char_;
typedef List<char* > _List_char__;
static List<char* > s__List_char__;

#define _List_char__DATA(x) ((List<char* >*) (EXTDATA(x)))
#define _List_char__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<char* > >::type))
#define _List_char__ISNT_DATA(x) (!_List_char__IS_DATA(x))

#define _List_char__CXX_DATA(x) (*(List<char* >*) (EXTDATA(VAL(x))))
#define _List_char__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<char* > >::type))
#define _List_char__CXX_ISNT_DATA(x) (!_List_char__CXX_IS_DATA(x))


PRIMITIVE STk_init__List_char__()
{
	Wrapper<_List_char__>::type = STk_new_CXXwrapper_id(
			Wrapper<_List_char__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_char_>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_char_>::markTypedList,
			(void (*)(SCM x))ListWrapper<_char_>::freeTypedList);
	Tcl_InitHashTable(&Register<_List_char__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_List_char__Methods(void);

PRIMITIVE STk_init_methods__List_char__()
{
	STk_add_new_cpp_primitive("List-char-make", tc_subr_0, 
	(PRIMITIVE (*)(...))  ListWrapper<_char_>::makeLinkList);
	STk_add_new_cpp_primitive("List-char?", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_char_>::linkListP);
	STk_add_new_cpp_primitive("list->List-char", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_char_>::stkList2LinkList);
	STk_add_new_cpp_primitive("List-char->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_char_>::linkList2STkList);
	genExtra_List_char__Methods();
	return UNDEFINED;
}
